'--------------------------------------------------------------------------------------------------------------
' Faktura-Software Scriptdatei 
' Funktion: 	Beleg des Mahnlaufes sollen direkt via E-Mail versendet werden. (Bsp Abo-Lauf)
' Ansicht:  	FakturaMahnlauf
' Script:	FakturaMahnlauf_04_EMailversand_Mahnlauf.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Dr. Frank Wietzel

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------

Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->

'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "003"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - Update 10.07.2011 bei rechtklick Sprache ignorieren
' - 10.07.2011 fwi Globale Variable BelegeMailShowDialog abfragen fr den E-Mail Dialog
'--------------------------------------------------------------------------------------------------------------
' Version 003
' - 'Betreff nderung 30.11.2011 fwi Betreff Eintrge aus der GlobVar auslesen und ersetzten
'--------------------------------------------------------------------------------------------------------------
' Version 004 
' - 
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "137"
sErrorSkript    = "004"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------

'Loginuser ermitteln
Dim sErf_User, oCurrentRecordset, iAnzahl_Ds, bFrage, sRecordid

sRecordid = GetViewContentbyName("Recordid")

sErf_User = cRM.CurrentProject.CurrentUser


Dim oViewConfig
Set oViewConfig = cRM.CurrentProject.ViewConfigs.ItemByName(CStr("FakturaMahnlauf_Belege"))

Dim oRecordSet
Set oRecordSet = oViewConfig.CreateRecordSet

' Abfragen ob Mahnungen in mehrerern Sprachen verschickt werden sollen:
Dim sGlobalView, sGlobalField, sGlobalErrorMsg, sGlobalVariable, sGlobalFilter

sGlobalView 		= "FakturaGlobaleEinstellungen"
sGlobalFilter		= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMailTextM_Multilang')"
sGlobalField			= "Result"
sGlobalErrorMsg		= "Fehler beim auslesen aus der Tabelle Factura_Software_Global :" & vbLf & sErrorCode & vbLf & "berprfen Sie ob der Eintrag <BelegeMailTextM_Multilang> in der Ansicht Factura_Software_Global vorhanden ist." & vbLf &vbLf & "Sollte dieser nicht vorhanden sein, so legen Sie diesen Datenastz (FS_Recordid) an." &vbLf &vbLf & "Bei Fragen knnen Sie sich gerne an den Support wenden." &vbLf

sGlobalVariable		= GetHiddenFieldContentByName(sGlobalView, sGlobalFilter,sGlobalField, sGlobalErrorMsg)  

Dim bMultilang

'-Update 10.07.2011 bei rechtklick Sprache ignorieren
If ((Ucase(sGlobalVariable)= Ucase("ja")) or (Ucase(sGlobalVariable)= Ucase("true"))) And Not WScript.RightClicked Then
 bMultilang = True
Else
 bMultilang = False
End If

Dim sSprache
if bMultilang Then
  sSprache = ShowInputbox("Geben Sie die gewnschte Sprache ein: " & vbLf &vbLf &" 1: Sprache 1 (Standardsprache)" &vbLf &" 2: Sprache 2" &vbLf &" 3: Sprache 3" &vbLf &" 4: Sprache 4" &vbLf,"1"  )
  If (NOt (IsNumeric(sSprache))) Or (sSprache > 4 ) Or (sSprache = " " ) Or (sSprache = "" )  Then
  	ShowMessage("FakturaMahnlauf_04_Emailversand_Mahnlauf.vbs: " & sErrorCode & vbLf & vbLf & sSprache & "als Nr fr die Sprache ist nicht erlaubt oder die Funktion wurde abgebrochen. Die Funktion wird beendet." )
  	FunktionBeenden
  End If
Else 
  sSprache = "1"
End If

If sSprache = "1" Then
 sSprache = ""
Else
 sSprache = "S" & sSprache
End If
'ShowMessage(sSprache)

'CurrentRecordset von den Mahnungen
Dim sFilter

sFilter	= """Factura_Mahnlauf_Belege"".""Mahnlauf_Recordid"" = 0x" &sRecordid

if not oRecordSet.SetFilter(sFilter) Then
  ShowMessage("FakturaMahnlauf_04_Emailversand_Mahnlauf.vbs: " & sErrorCode & vbLf & vbLf & "Filter auf FakturaMahnlauf_Belege kann nicht ausgefhrt werden. Die Funktion wird beendet." )
  FunktionBeenden
End If

iAnzahl_Ds = oRecordSet.RecCount
if iAnzahl_Ds = 0 Then
  ShowMessage("Es befinden sich keine Belege im Mahnlauf. Die Funktion wird beendet")
  FunktionBeenden
Else
  'Ansonsten Hinweis ob die Belege via e-Mail versendet werden sollen
  bFrage	= ShowQuestion("Mchten Sie wirklich diese " & oRecordSet.RecCount &" Mahnungen direkt per E-Mail versenden.")
End if

if not bFrage then
  ShowMessage("Diese Funktion wird beendet.")
  FunktionBeenden
End if


  'geht zum ersten Datensatz (er sollt nur einer haben)
 if oRecordSet.MoveFirst then
  'Datensatz auslesen
  Dim oCurrentRecord, sEMail, i, sBelegNummer, sFirmenName, sBelegDat, sAnhang,sSubject , sContent, bDialog, sAnrede, sBelegTypenID, sMahnstufe, sMahndatum, sName, sDeutscheMahnstufe

	for i = 1 To iAnzahl_Ds '2 ' iAnzahl_Ds
		Set oCurrentRecord 	= oRecordSet.CurrentRecordSynchronized
  		sEMail 				= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Email")
		sBelegNummer		= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Belegnr")
		sBelegDat  			= Mid(oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Belegdat"),1,10)
		sAnrede				= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Anrede")
		sName				= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Name")
		sMahnstufe			= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Mahnstufe")
		
		sMahndatum			= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Mahndatum")
		If (sMahnstufe = "") Or (sMahnstufe = " ") Or (sMahnstufe = "0") Then
			sSubject	= "Zahlungserinnerung"
			sMahnstufe	= "0"
		Else 
			sSubject	= "Mahnung " &sMahnstufe
		End If
		
		sDeutscheMahnstufe = sSubject
		
		sAnhang				= CreatePDF(sBelegNummer) 
		'ShowMessage("2")
		sBelegTypenID	=oCurrentRecord.GetContentsByName("Beleg_Typen_Recordid.FakturaBeleg_Typen.Recordid.ID")
		'ShowMessage("3")
		sSubject 		=  sSubject & " Rechnung Nr. " & sBelegNummer & " vom " & sBelegDat
		
		If (sName = "") Or (sName = " ") Then
			sContent		=  "Sehr geehrte Damen und Herren"
		Else
			sContent		=  sAnrede & " " & sName
		End If		
		
		If sSprache <> "" Then
			sContent = ""
		End If
		
		sGlobalFilter	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMailTextM" &sMahnstufe &sSprache &"')"
		
		'ShowMessage(sGlobalFilter)
		
		sContent		= sContent & GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Fehler in FakturaMahnlauf_04_EMailverand_Mahnlauf.vbs ... " & "Belegnummer: " & sBelegNummer )

		'Betreff nderung 30.11.2011
		sGlobalFilter	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMailBetreffM" &sMahnstufe &sSprache &"')"
		sSubject		= GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Fehler in FakturaMahnlauf_04_EMailverand_Mahnlauf.vbs ... " & "Belegnummer: " & sBelegNummer )
	
		'Platzhalter ersetzen 
		sSubject		= Replace(sSubject,"%BELEGDAT%",sBelegDat)
		sSubject		= Replace(sSubject,"%BELEGNR%",sBelegNummer)
		sSubject		= Replace(sSubject,"%MANSTUFEDE%",sDeutscheMahnstufe)
		sSubject		= Replace(sSubject,"%MANSTUFENR%",sMahnstufe)
		sSubject		= Replace(sSubject,"%MANSTUFENR+1%",Cint(sMahnstufe)+1)


		'ShowMessage(sContent)
		'Update 10.07.2011 fwi
		sGlobalView 		= "FakturaGlobaleEinstellungen"
		sGlobalFilter		= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMailShowDialog')"
		sGlobalField		= "Result"
		sGlobalErrorMsg		= "Fehler beim auslesen aus der Tabelle Factura_Software_Global :" & vbLf & sErrorCode & vbLf & "berprfen Sie ob der Eintrag <BelegeMailShowDialog> in der Ansicht Factura_Software_Global vorhanden ist." & vbLf &vbLf & "Sollte dieser nicht vorhanden sein, so legen Sie diesen Datenastz (FS_Recordid) an." &vbLf &vbLf & "Bei Fragen knnen Sie sich gerne an den Support wenden." &vbLf
		
		sGlobalVariable		= GetHiddenFieldContentByName(sGlobalView, sGlobalFilter,sGlobalField, sGlobalErrorMsg)  
	
	'	ShowMessage (sGlobalVariable)
		'Betreff der E-Mail verwalten:
		
		
		
		
	
		if (Ucase(sGlobalVariable)= Ucase("ja")) or (Ucase(sGlobalVariable)= Ucase("true")) Then
			bDialog		= True
		Else
			bDialog		= False
		End If 		
		'Ende Update 10.07.2011 fwi

		'Erzeuge PDF
		if (sAnhang = "") or (len(sAnhang) < 3) Then
  			ShowMessage("PDF wurde nicht korrekt erzeugt, und kann nicht dem Anhang hinzugefgt werden. Diese Funktion wird beendet.")
  			FunktionBeenden
		End if

		'ShowMessage(sEMail)
		If InStr(sEMail,"@") > 0 Then
			sendMapiMail sEMail, sSubject, sContent, sAnhang, bDialog
		Else
		  ShowMessage("E-Mail Adresse in Beleg " &sBelegNummer & " vom " & sBelegDat & " nicht vorhanden oder nicht korrekt. Mahnung per E-Mail kann fr diesen Beleg nicht druchgefhrt werden." )
		End If
		
		'Programmieren Belegstatus Status ndern auf E-Mail versendet
		
		oRecordSet.MoveNext
		
	Next


 Else
  ShowMessage("Der Vorgang wurde beendet. - unerwartetes Ende")
  FunktionBeenden
 End if



Function CreatePDF(sBelegNummer)

Dim sBelegTyp, sDateiname, sOutputfile, sBelegID, sFilter2, sBelegtypRecordid, sFilterBelegTyp, spfad, sType


'Dateiname generieren
sDateiname =  cRM.CurrentProject.GetSessionProperty ("cRM_Projekt_Dokumentaufbau","1")

'ShowMessage(sDateiname)

sDateiname = StringReplace  (sDateiname, "<Belegnr>",sBelegNummer)
sDateiname = StringReplace (sDateiname, "<Firma>",sSubject)



'Stringreplace
sDateiname = StringReplace (sDateiname, ".", "_")
sDateiname = StringReplace (sDateiname, " ", "_")
sDateiname = StringReplace (sDateiname, "?", "")
sDateiname = StringReplace (sDateiname, "", "ss")

Dim sDatei

sDatei = sDateiname

'.pdf anhngen
sDateiname = sDateiname & ".pdf"

Dim sView, sField, sErrorMsg

sView 		= "FakturaGlobaleEinstellungen"
sFilter2	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'Mahnwesen_Mahn_Pfad')"
sField		= "Result"
sErrorMsg	= "Error Mahnlauf 004"

sOutputfile = GetHiddenFieldContentByName(sView, sFilter2,sField, sErrorMsg)  

If (sOutputfile = "") Or (sOutputfile = " ") then  
  sOutputfile=cRM.CurrentProject.GetSessionProperty("cRM_Projekt_Path_Belege",True) & sDateiname
Else
  sOutputfile = ReplacePfad (sOutputfile) & sDateiname
End If

'ShowMessage(sOutputfile)

'Reportdatei fr die Einzelmahnung finden
sFilter2	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'Mahnwesen_Druckvorlage_Einzeldruck" & sSprache &"')"
sField		= "Result"
sErrorMsg	= "Error Mahnlauf 005"


spfad =  GetHiddenFieldContentByName(sView, sFilter2,sField, sErrorMsg)  
spfad = ReplacePfad (sPfad)

'Dateityp
sType ="PDF"
'ShowMessage("Parameteraufruf von PrintSingelListinFile: " & spfad & vbLf & vblf & sType & vbLf & vblf& sOutputfile & vbLf )
'Erstellen der Datei und Hinweis
'PrintSingelListinFile spfad,sType,
oRecordSet.PrintCard "PDF", spfad, True, False, sOutputfile
'PrintSingelCardtoPdfnoMessage(sReportFilePath,sFile)

'ShowMessage(sOutputfile & " wurde hinterlegt")

CreatePDF = sOutputfile

End Function




Function ReplacePfad (sString)

  Dim sPRJDIR,sAPPDIR,sUSERDIR,sTEMPDIR, sNewString

  sPRJDIR   = "%PRJDIR%"
  sAPPDIR   = "%APPDIR%"
  sUSERDIR = "%USERDIR%"
  sTEMPDIR = "%TEMPDIR%"
  
  if instr(sString,"%PRJDIR") > 0 Then
     sNewString  = StringReplace (sString, "%PRJDIR", sPRJDIR)
  End if
  
  if instr(sString,"%APPDIR") > 0 Then
     sNewString  = StringReplace (sString, "%APPDIR", sAPPDIR)
  End if
  
  if instr(sString,"%USERDIR") > 0 Then
     sNewString  = StringReplace (sString, "%USERDIR", sUSERDIR)
  End if
  
  if instr(sString,"%TEMPDIR") > 0 Then
     sNewString  = StringReplace (sString, "%TEMPDIR", sTEMPDIR)
  End if

  ReplacePfad= StringReplace (sNewString, "%", "") 

End Function





Sub FunktionBeenden()

  Set oCurrentRecordset = Nothing


Wscript.Quit

End Sub







