'--------------------------------------------------------------------------------------------------------------
' Faktura-Software Scriptdatei 
' Funktion: 	Beleg des Mahnlaufes sollen direkt via E-Mail versendet werden. (Bsp Abo-Lauf)
' Ansicht: 	FakturaMahnlauf
' Script:	FakturaMahnlauf_05_EMailversand_Einzelmahnung.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Dr. Frank Wietzel

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->

'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "003"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - Update 10.07.2011 bei rechtklick Sprache ignorieren
' - 10.07.2011 fwi Globale Variable BelegeMailShowDialog abfragen fr den E-Mail Dialog
'--------------------------------------------------------------------------------------------------------------
' Version 003
' - 'Betreff nderung 30.11.2011 fwi Betreff Eintrge aus der GlobVar auslesen und ersetzten
'--------------------------------------------------------------------------------------------------------------
' Version 004 
' - 
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "137"
sErrorSkript    = "005"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------

'Loginuser ermitteln
Dim sErf_User, oCurrentRecordset, iAnzahl_Ds, bFrage

sErf_User = cRM.CurrentProject.CurrentUser


Dim oViewConfig
Set oViewConfig = cRM.CurrentProject.ViewConfigs.ItemByName(CStr("FakturaMahnlauf_Belege"))

Dim oRecordSet
Set oRecordSet = oViewConfig.CreateRecordSet

' Abfragen ob Mahnungen in mehrerern Sprachen verschickt werden sollen:
Dim sGlobalView, sGlobalField, sGlobalErrorMsg, sGlobalVariable, sGlobalFilter

sGlobalView 		= "FakturaGlobaleEinstellungen"
sGlobalFilter		= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMailTextM_Multilang')"
sGlobalField			= "Result"
sGlobalErrorMsg		= "Fehler beim auslesen aus der Tabelle Factura_Software_Global :" & vbLf & sErrorCode & vbLf & "berprfen Sie ob der Eintrag <BelegeMailTextM_Multilang> in der Ansicht Factura_Software_Global vorhanden ist." & vbLf &vbLf & "Sollte dieser nicht vorhanden sein, so legen Sie diesen Datenastz (FS_Recordid) an." &vbLf &vbLf & "Bei Fragen knnen Sie sich gerne an den Support wenden." &vbLf

sGlobalVariable		= GetHiddenFieldContentByName(sGlobalView, sGlobalFilter,sGlobalField, sGlobalErrorMsg)  

Dim bMultilang

'-Update 10.07.2011 bei rechtklick Sprache ignorieren
If ((Ucase(sGlobalVariable)= Ucase("ja")) or (Ucase(sGlobalVariable)= Ucase("true"))) And Not WScript.RightClicked Then
 bMultilang = True
Else
 bMultilang = False
End If

Dim sSprache
if bMultilang Then
  sSprache = ShowInputbox("Geben Sie die gewnschte Sprache ein: " & vbLf &vbLf &" 1: Sprache 1 (Standardsprache)" &vbLf &" 2: Sprache 2" &vbLf &" 3: Sprache 3" &vbLf &" 4: Sprache 4" &vbLf,"1"  )
  If (NOt (IsNumeric(sSprache))) Or (sSprache > 4 ) Or (sSprache = " " ) Or (sSprache = "" )  Then
  	ShowMessage("FakturaMahnlauf_04_Emailversand_Mahnlauf.vbs: " & sErrorCode & vbLf & vbLf & sSprache & "als Nr fr die Sprache ist nicht erlaubt oder die Funktion wurde abgebrochen. Die Funktion wird beendet." )
  	FunktionBeenden
  End If
Else 
  sSprache = "1"
End If

If sSprache = "1" Then
 sSprache = ""
Else
 sSprache = "S" & sSprache
End If

'CurrentRecordset von den Mahnungen
Dim sFilter

sFilter	= "1=1"

if not oRecordSet.SetFilter(sFilter) Then
  ShowMessage("FakturaMahnlauf_04_Emailversand_Mahnlauf.vbs: " & sErrorCode & vbLf & vbLf & "Filter auf FakturaMahnlauf_Belege kann nicht ausgefhrt werden. Die Funktion wird beendet." )
  FunktionBeenden
End If


dim oinputform, sContainerName, oCurrentRecord, sRecordidMahnung
Set oinputform = cRM.CurrentProject.ActiveViews.ActiveView.CurrentInputForm(2)

sContainerName = "Recordid.FakturaMahnlauf_Belege.Mahnlauf_Recordid#{B6B73F48-CBC4-4B07-96C0-16F349CEBA20}"

Dim oContainers, oContainer

Set oContainers = oInputForm.Containers
Set oContainer = oContainers.ItemByName(sContainerName)

Set oCurrentRecord = oContainer.CurrentRecord


sRecordidMahnung = oCurrentRecord.GetContentsByName("Recordid")


  'Datensatz des Constainers auslesen
  Dim sEMail, i, sBelegNummer, sFirmenName, sBelegDat, sAnhang,sSubject , sContent, bDialog, sAnrede, sBelegTypenID, sMahnstufe, sMahndatum, sName, sDeutscheMahnstufe

	'Set oCurrentRecord 	= oRecordSet.CurrentRecordSynchronized
  	sEMail 				= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Email")
	sBelegNummer		= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Belegnr")
	sBelegDat  			= Mid(oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Belegdat"),1,10)
	sAnrede				= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Anrede")
	sName				= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Name")
	sMahnstufe			= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Mahnstufe")
	sMahndatum			= oCurrentRecord.GetContentsByName("Belege_Recordid.FakturaBelege.Recordid.Mahndatum")
	If (sMahnstufe = "") Or (sMahnstufe = " ") Or (sMahnstufe = "0") Then
		sSubject	= "Zahlungserinnerung"
		sMahnstufe	= "0"
	Else 
		sSubject	= "Mahnung " &sMahnstufe
	End if
		
	sDeutscheMahnstufe = sSubject
		
	'PDF erstellen
	sAnhang				= CreatePDF(sBelegNummer) 

	sBelegTypenID	=oCurrentRecord.GetContentsByName("Beleg_Typen_Recordid.FakturaBeleg_Typen.Recordid.ID")

	sSubject 		=  sSubject & " Rechnung Nr. " & sBelegNummer & " vom " & sBelegDat
		
	If (sName = "") Or (sName = " ") Then
		sContent		=  "Sehr geehrte Damen und Herren"
	Else
		sContent		=  sAnrede & " " & sName
	End If		
		
		
	sGlobalFilter	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMailTextM" &sMahnstufe &sSprache &"')"
	
	'ShowMessage(sGlobalFilter)
		If sSprache <> "" Then
			sContent = ""
		End If
		
	sContent		= sContent & GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Fehler in FakturaMahnlauf_04_EMailverand_Mahnlauf.vbs ... " & "Belegnummer: " & sBelegNummer )

	'Betreff nderung 30.11.2011
	sGlobalFilter	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMailBetreffM" &sMahnstufe &sSprache &"')"
	sSubject		= GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Fehler in FakturaMahnlauf_04_EMailverand_Mahnlauf.vbs ... " & "Belegnummer: " & sBelegNummer )
	
	'Platzhalter ersetzen 
	sSubject		= Replace(sSubject,"%BELEGDAT%",sBelegDat)
	sSubject		= Replace(sSubject,"%BELEGNR%",sBelegNummer)
	sSubject		= Replace(sSubject,"%MANSTUFEDE%",sDeutscheMahnstufe)
	sSubject		= Replace(sSubject,"%MANSTUFENR%",sMahnstufe)
	sSubject		= Replace(sSubject,"%MANSTUFENR+1%",Cint(sMahnstufe)+1)


	sGlobalView 		= "FakturaGlobaleEinstellungen"
	sGlobalFilter		= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMailShowDialog')"
	sGlobalField		= "Result"
	sGlobalErrorMsg		= "Fehler beim auslesen aus der Tabelle Factura_Software_Global :" & vbLf & sErrorCode & vbLf & "berprfen Sie ob der Eintrag <BelegeMailShowDialog> in der Ansicht Factura_Software_Global vorhanden ist." & vbLf &vbLf & "Sollte dieser nicht vorhanden sein, so legen Sie diesen Datenastz (FS_Recordid) an." &vbLf &vbLf & "Bei Fragen knnen Sie sich gerne an den Support wenden." &vbLf
	
	sGlobalVariable		= GetHiddenFieldContentByName(sGlobalView, sGlobalFilter,sGlobalField, sGlobalErrorMsg)  

'	ShowMessage (sGlobalVariable)

	'Update 10.07.2011 fwi
	if (Ucase(sGlobalVariable)= Ucase("ja")) or (Ucase(sGlobalVariable)= Ucase("true")) Then
		bDialog		= True
	Else
		bDialog		= False
	End If 		
	
		
	'Hinweis, wenn kein PDF erzeugt wurde
	if (sAnhang = "") or (len(sAnhang) < 3) then
  		ShowMessage("PDF wurde nicht korrekt erzeugt, und kann nicht dem Anhang hinzugefgt werden. Diese Funktion wird beendet.")
  		FunktionBeenden
	End if

	'ShowMessage(sEMail)
	If InStr(sEMail,"@") > 0 Then
		sendMapiMail sEMail, sSubject, sContent, sAnhang, bDialog
	Else
	  ShowMessage("E-Mail Adresse in Beleg " &sBelegNummer & " vom " & sBelegDat & " nicht vorhanden oder nicht korrekt. Mahnung per E-Mail kann fr diesen Beleg nicht druchgefhrt werden." )
	End If
		
	'Programmieren Belegstatus Status ndern auf E-Mail versendet
		
	

Function CreatePDF(sBelegNummer)

Dim sBelegTyp, sDateiname, sOutputfile, sBelegID, sFilter2, sBelegtypRecordid, sFilterBelegTyp, spfad, sType


'Dateiname generieren
sDateiname =  cRM.CurrentProject.GetSessionProperty ("cRM_Projekt_Dokumentaufbau","1")

'ShowMessage(sDateiname)

sDateiname = StringReplace  (sDateiname, "<Belegnr>",sBelegNummer)
sDateiname = StringReplace (sDateiname, "<Firma>",sSubject)



'Stringreplace
sDateiname = StringReplace (sDateiname, ".", "_")
sDateiname = StringReplace (sDateiname, " ", "_")
sDateiname = StringReplace (sDateiname, "?", "")
sDateiname = StringReplace (sDateiname, "", "ss")

Dim sDatei

sDatei = sDateiname

'.pdf anhngen
sDateiname = sDateiname & ".pdf"

Dim sView, sField, sErrorMsg

sView 	= "FakturaGlobaleEinstellungen"
sFilter2	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'Mahnwesen_Mahn_Pfad')"
sField		= "Result"
sErrorMsg	= "Error Mahnlauf 004"

sOutputfile = GetHiddenFieldContentByName(sView, sFilter2,sField, sErrorMsg)  

If (sOutputfile = "") Or (sOutputfile = " ") then  
  sOutputfile=cRM.CurrentProject.GetSessionProperty("cRM_Projekt_Path_Belege",True) & sDateiname
Else
  sOutputfile = ReplacePfad (sOutputfile) & sDateiname
End If

'ShowMessage(sOutputfile)

'Reportdatei fr die Einzelmahnung finden
sFilter2	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'Mahnwesen_Druckvorlage_Einzeldruck" & sSprache &"')"
sField		= "Result"
sErrorMsg	= "Error Mahnlauf 005"


spfad =  GetHiddenFieldContentByName(sView, sFilter2,sField, sErrorMsg)  
spfad = ReplacePfad (sPfad)

'Dateityp
sType ="PDF"
'ShowMessage("Parameteraufruf von PrintSingelListinFile: " & spfad & vbLf & vblf & sType & vbLf & vblf& sOutputfile & vbLf )
'Erstellen der Datei und Hinweis
'PrintSingelListinFile spfad,sType,
'Update AM
oCurrentRecord.PrintCard "PDF", spfad, True, sOutputfile ' Neu AM
'oRecordSet.PrintCard "PDF", spfad, True, False, sOutputfile ' Vorheriger Stand fwi
'/ Update AM
'PrintSingelCardtoPdfnoMessage(sReportFilePath,sFile)

'ShowMessage(sOutputfile & " wurde hinterlegt")

CreatePDF = sOutputfile

End Function




Function ReplacePfad (sString)

  Dim sPRJDIR,sAPPDIR,sUSERDIR,sTEMPDIR, sNewString

  sPRJDIR   = "%PRJDIR%"
  sAPPDIR   = "%APPDIR%"
  sUSERDIR = "%USERDIR%"
  sTEMPDIR = "%TEMPDIR%"
  
  if instr(sString,"%PRJDIR") > 0 Then
     sNewString  = StringReplace (sString, "%PRJDIR", sPRJDIR)
  End if
  
  if instr(sString,"%APPDIR") > 0 Then
     sNewString  = StringReplace (sString, "%APPDIR", sAPPDIR)
  End if
  
  if instr(sString,"%USERDIR") > 0 Then
     sNewString  = StringReplace (sString, "%USERDIR", sUSERDIR)
  End if
  
  if instr(sString,"%TEMPDIR") > 0 Then
     sNewString  = StringReplace (sString, "%TEMPDIR", sTEMPDIR)
  End if

  ReplacePfad= StringReplace (sNewString, "%", "") 

End Function





Sub FunktionBeenden()

  Set oCurrentRecordset = Nothing


Wscript.Quit

End Sub







